package br.ufes.inf.prog3.lista2.exercicio01;

/**
 * Classe que representa uma conta-corrente bancária.
 * 
 * Parte do exercício 1, da lista 2.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class ContaCorrente {
	/** Saldo da conta corrente. */
	private double saldo;
	
	/** Retorna a taxa de operação da conta corrente */
	protected double getTaxaOperacao() {
		return 0.5;
	}
	
	/** Deposita uma quantia na conta corrente. */
	public void depositar(double quantia) {
		saldo += quantia;
	}
	
	/** Saca uma quantia da conta corrente. */
	public void sacar(double quantia) {
		saldo -= quantia + getTaxaOperacao() * quantia;
	}
	
	/** Retorna o saldo da conta corrente. */
	public double getSaldo() {
		return saldo;
	}
}
