package br.ufes.inf.prog3.lista2.exercicio02b;

/**
 * Classe que representa um produto da loja.
 * 
 * Parte do exercício 2b, da lista 2.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public abstract class Produto {
	/** Código de barras. */
	private int codigoBarras;
	
	/** Nome do produto. */
	private String nome;
	
	/** Preço do produto. */
	private double preco;
	
	/** Construtor. */
	public Produto(int codigoBarras, String nome, double preco) {
		this.codigoBarras = codigoBarras;
		this.nome = nome;
		this.preco = preco;
	}

	/** @see java.lang.Object#toString() */
	@Override
	public String toString() {
		return "[" + codigoBarras + "] " + nome + "; R$ " + preco;
	}

	/** @see java.lang.Object#equals(java.lang.Object) */
	@Override
	public boolean equals(Object obj) {
		if (! (obj instanceof Produto)) return false;
		return codigoBarras == ((Produto)obj).codigoBarras;
	}
}
