package br.ufes.inf.prog3.lista2.exercicio02c;

/**
 * Classe que representa um produto da loja.
 * 
 * Parte do exercício 2c, da lista 2.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public abstract class Produto implements Comparable<Produto> {
	/** Código de barras. */
	private int codigoBarras;
	
	/** Nome do produto. */
	private String nome;
	
	/** Preço do produto. */
	private double preco;
	
	/** Construtor. */
	public Produto(int codigoBarras, String nome, double preco) {
		this.codigoBarras = codigoBarras;
		this.nome = nome;
		this.preco = preco;
	}

	/** @see java.lang.Object#toString() */
	@Override
	public String toString() {
		return "[" + codigoBarras + "] " + nome + "; R$ " + preco;
	}

	/** @see java.lang.Object#equals(java.lang.Object) */
	@Override
	public boolean equals(Object obj) {
		if (! (obj instanceof Produto)) return false;
		return codigoBarras == ((Produto)obj).codigoBarras;
	}

	/** @see java.lang.Comparable#compareTo(java.lang.Object) */
	@Override
	public int compareTo(Produto o) {
		int cmp;
		
		// Ordenação por nome:
		cmp = nome.compareTo(o.nome);
		
		// Ordenação por preço.
		// cmp = (preco > o.preco) ? 1 : (preco < o.preco) ? -1 : 0;
		
		return cmp;
	}
}
