package br.ufes.inf.prog3.lista2.exercicio03;

import java.util.Scanner;

/**
 * Classe principal do exercício 3, da lista 2.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Exercicio03 {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		
		// Pergunta quantas formas serão criadas.
		System.out.println("Quantas formas deseja criar?");
		int qtd = scanner.nextInt();
		Forma[] formas = new Forma[qtd];
		
		// Cria o número de formas indicado.
		int i = 0;
		while (i < qtd) {
			// Pergunta que forma se deseja criar.
			System.out.println("Que forma deseja criar: [Q]uadrado; [R]etângulo; [C]írculo?");
			char escolha = scanner.next().toLowerCase().charAt(0);
			
			// Verifica qual foi a forma escolhida.
			switch(escolha) {
			case 'q':
				System.out.print("Digite o tamanho do lado: ");
				formas[i++] = new Quadrado(scanner.nextDouble());
				break;
				
			case 'r':
				System.out.print("Digite o tamanho da base e da altura: ");
				formas[i++] = new Retangulo(scanner.nextDouble(), scanner.nextDouble());
				break;
				
			case 'c':
				System.out.print("Digite o tamanho do raio: ");
				formas[i++] = new Circulo(scanner.nextDouble());
				break;
				
			default:
				System.out.println("Opção inválida.");	
			}
		}
		
		// Imprime na tela as formas utilizando instanceof e downcast.
		System.out.println("\nFormas criadas: ");
		for (i = 0; i < formas.length; i++) {
			Forma f = formas[i];
			if (f instanceof Quadrado) {
				Quadrado q = (Quadrado)f;
				System.out.println(i + " - Quadrado de lado " + q.getLado());
			}
			else if (f instanceof Retangulo) {
				Retangulo r = (Retangulo)f;
				System.out.println(i + " - Retângulo de base " + r.getBase() + " e altura " + r.getAltura());
			}
			else if (f instanceof Circulo) {
				Circulo c = (Circulo)f;
				System.out.println(i + " - Círculo de raio " + c.getRaio());
			}
		}
		
		// Imprime os perímetros das formas.
		System.out.println("\nPerímetros das formas: ");
		for (i = 0; i < formas.length; i++) System.out.println(i + " - " + formas[i].calcularPerimetro());
		
		// Imprime as áreas das formas.
		System.out.println("\nÁreas das formas: ");
		for (i = 0; i < formas.length; i++) System.out.println(i + " - " + formas[i].calcularArea());
		
		scanner.close();
	}
}
