package br.ufes.inf.prog3.lista2.exercicio06;

/**
 * Fábrica de lâmpadas: cria objetos que seguem a interface Lampada.
 * 
 * Parte do exercício 6, da lista 2.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class FabricaLampadaMembro {
	/** Classe interna membro que representa uma lâmpada incandescente. */
	class Incandescente implements Lampada {
		/** @see br.ufes.inf.prog3.lista2.exercicio05.Lampada#ligar() */
		@Override
		public void ligar() {
			System.out.println("Ligou incandescente.");
		}

		/** @see br.ufes.inf.prog3.lista2.exercicio05.Lampada#desligar() */
		@Override
		public void desligar() {
			System.out.println("Desligou incandescente.");
		}
	}

	/** Classe interna membro que representa uma lâmpada fluorescente. */
	class Fluorescente implements Lampada {
		/** @see br.ufes.inf.prog3.lista2.exercicio05.Lampada#ligar() */
		@Override
		public void ligar() {
			System.out.println("Ligou fluorescente.");
		}

		/** @see br.ufes.inf.prog3.lista2.exercicio05.Lampada#desligar() */
		@Override
		public void desligar() {
			System.out.println("Desligou fluorescente.");
		}
	}
	
	/** Constrói uma lâmpada, selecionando o tipo dependendo do parâmetro. */
	public Lampada construir(boolean fluorescente) {
		return fluorescente ? new Fluorescente() : new Incandescente();
	}
}
