package br.ufes.inf.prog3.lista2.exercicio07;

/**
 * Classe que implementa uma lista encadeada.
 *
 * Parte do exercício 6, da lista 2.
 * 
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class ListaEncadeada {
	/** Tamanho da lista. */
	private int tamanho;
	
	/** Primeiro nó da lista. */
	private No primeiro;
	
	/** Último nó da lista. */
	private No ultimo;
	
	/** Classe interna membro que implementa um nó da lista. */
	class No {
		/** O conteúdo do nó. */
		private Par par;
		
		/** Próximo nó. */
		private No proximo;
		
		/** Construtor. */
		private No(int x, int y) {
			par = new Par(x, y);
		}
		
		/** @see java.lang.Object#toString() */
		@Override
		public String toString() {
			return "" + par;
		}
	}
	
	/** Classe interna aninhada que implementa um par de números, conteúdo da lista. */
	static class Par {
		/** Primeiro número do par. */ 
		private int x;

		/** Segundo número do par. */ 
		private int y;
		
		/** Construtor. */
		private Par(int x, int y) {
			this.x = x;
			this.y = y;
		}
		
		/** @see java.lang.Object#toString() */
		@Override
		public String toString() {
			return "(" + x + ", " + y + ")";
		}
	}
	
	/** Adiciona um par à lista. */
	public void adicionar(int x, int y) {
		No novoNo = new No(x, y);
		
		// Se a lista está vazia, adiciona de forma trivial.
		if (ultimo == null) {
			primeiro = ultimo = novoNo;
		}
		
		// Do contrário, adiciona ao final da lista.
		else {
			ultimo.proximo = novoNo;
			ultimo = novoNo;
		}
		
		// A lista aumentou de tamanho.
		tamanho++;
	}
	
	/** Obtém um vetor de nós para que programas externos possam imprimir a lista. */
	public No[] asArray() {
		No[] vetor = new No[tamanho];
		int i = 0;
		for (No no = primeiro; no != null; no = no.proximo) vetor[i++] = no;
		return vetor;
	}
}
